/*
 * PETALS: PETALS Services Platform
 * Copyright (C) 2005  EBM WebSourcing
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA.
 *
 * Initial developer(s): EBM WebSourcing
 * --------------------------------------------------------------------------
 * $Id: 
 * --------------------------------------------------------------------------  
 */
package org.objectweb.petals.admin;

import org.eclipse.gef.ui.actions.ActionBarContributor;
import org.eclipse.gef.ui.actions.DeleteRetargetAction;
import org.eclipse.gef.ui.actions.RedoRetargetAction;
import org.eclipse.gef.ui.actions.UndoRetargetAction;
import org.eclipse.jface.action.IToolBarManager;
import org.eclipse.ui.actions.ActionFactory;

/**
 * @author Maxime Carpentier
 *
 *  Add  buttons to Eclipse's toolbar
 */
public class EsbContributor extends ActionBarContributor {

  public EsbContributor() {
  }

  /**
 * @see org.eclipse.gef.ui.actions.ActionBarContributor#buildActions()
 * register basic actions to ActionRegistry
 */
protected void buildActions() {
    addRetargetAction(new UndoRetargetAction());
    addRetargetAction(new RedoRetargetAction());
    addRetargetAction(new DeleteRetargetAction());
  }

  protected void declareGlobalActionKeys() {

  }

  /**
 * @see org.eclipse.ui.part.EditorActionBarContributor#contributeToToolBar(org.eclipse.jface.action.IToolBarManager)
 * Add basic actions to the toolbar
 */
public void contributeToToolBar(IToolBarManager toolBarManager) {
  	toolBarManager.add(getAction(ActionFactory.DELETE.getId()));
  	
    toolBarManager.add(getActionRegistry().getAction(ActionFactory.UNDO.getId()));

    toolBarManager.add(getActionRegistry().getAction(ActionFactory.REDO.getId()));

  }

  
}