/*
 * PETALS: PETALS Services Platform
 * Copyright (C) 2005  EBM WebSourcing
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA.
 *
 * Initial developer(s): EBM WebSourcing
 * --------------------------------------------------------------------------
 * $Id: 
 * --------------------------------------------------------------------------  
 */

package org.objectweb.petals.admin.editparts;

import java.beans.PropertyChangeEvent;
import java.util.List;

import org.eclipse.draw2d.FlowLayout;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.Panel;
import org.eclipse.gef.EditPolicy;
import org.objectweb.petals.admin.editpolicies.ContentsServiceContainerLayoutEditPolicy;
import org.objectweb.petals.admin.models.ContentsServiceContainerModel;


/**
 * @author Maxime Carpentier
 */

public class ContentsServiceContainerEditPart extends EditPartWithListener {

		public static int _SPACING = 10;


		private int height = 150;
		/**
		 * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
		 * initilaize the graphical representation of the model
		 */
	protected IFigure createFigure() {
		Panel figure = new Panel();
		FlowLayout fl = new FlowLayout(true);
		fl.setMajorAlignment(FlowLayout.ALIGN_CENTER);
		fl.setMinorSpacing(_SPACING);
		figure.setLayoutManager(fl);
		Panel essai = new Panel();
		essai.setSize(1,height);
		figure.add(essai);
		return figure;
	}
	
	/**
	 * @see org.eclipse.gef.editparts.AbstractEditPart#createEditPolicies()
	 */
	protected void createEditPolicies() {
		installEditPolicy(EditPolicy.LAYOUT_ROLE, new ContentsServiceContainerLayoutEditPolicy());
	}

	/**)
	 * @see org.eclipse.gef.editparts.AbstractEditPart#getModelChildren()
	 */
	protected List getModelChildren() {
		return ((ContentsServiceContainerModel) getModel()).getChildren();
	}
	
	/**
	 * @see java.beans.PropertyChangeListener#propertyChange(java.beans.PropertyChangeEvent)
	 * called when model changes; it updates the model's figure when required
	 */
	public void propertyChange(PropertyChangeEvent evt) {
	   	if (evt.getPropertyName().equals(ContentsServiceContainerModel.P_CHILDREN)) {
	    	refreshVisuals();
	    	refreshChildren();
	    }
	  }

	/**
	 * @see ebm.dev.esb.editparts.EditPartWithListener#getEditPartType()
	 */
	public int getEditPartType() {
		return _CONTENTS_SERVICE_CONTAINER_EDIT_PART;
	}
	
	}
