/*
 * PETALS: PETALS Services Platform
 * Copyright (C) 2005  EBM WebSourcing
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA.
 *
 * Initial developer(s): EBM WebSourcing
 * --------------------------------------------------------------------------
 * $Id: 
 * --------------------------------------------------------------------------  
 */

package org.objectweb.petals.admin.editparts;

import java.beans.PropertyChangeEvent;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.Label;
import org.objectweb.petals.admin.models.ComponentsModel;
import org.objectweb.petals.admin.models.ServiceContainerTitleModel;
import org.objectweb.petals.admin.tools.ComponentsTitleFigure;


/**
* @author Maxime Carpentier
*/
public class ServiceContainerTitleEditPart extends EditPartWithListener {

	/**
	 * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
	 */
	private Label label;
	
	/**
	 * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
	 * initilaize the graphical representation of the model
	 */
	protected IFigure createFigure() {
		ServiceContainerTitleModel model = (ServiceContainerTitleModel) getModel();
		ComponentsTitleFigure figure = new ComponentsTitleFigure(model.getTitle(),ComponentsModel.CalculateInitialContainerSize().width);
	//	model.setConstraint(new Rectangle(figure.getLocation(),figure.getSize()));
		return figure;
	}
	
	/**
	 * @see java.beans.PropertyChangeListener#propertyChange(java.beans.PropertyChangeEvent)
	 * called when model changes; it updates the model's figure when required
	 */
	public void propertyChange(PropertyChangeEvent evt) {
		if (evt.getPropertyName().equals(ServiceContainerTitleModel.P_CONSTRAINT) || evt.getPropertyName().equals(ServiceContainerTitleModel.P_NAME))
			refreshVisuals(); 
		if (evt.getPropertyName().equals(ServiceContainerTitleModel.P_TITLE)) {
			((ComponentsTitleFigure) getFigure()).setName(((ServiceContainerTitleModel) getModel()).getTitle()); 
		}
	}
	/**
	 * @see org.objectweb.petals.admin.editparts.EditPartWithListener#getEditPartType()
	 */
	public int getEditPartType() {
		return _SERVICE_CONTAINER_TITLE_EDIT_PART;
	}
	/**
	 * @see org.eclipse.gef.editparts.AbstractEditPart#createEditPolicies()
	 */
	protected void createEditPolicies() {
	}

	/**
	 * @see org.eclipse.gef.editparts.AbstractEditPart#refreshVisuals()
	 */
	protected void refreshVisuals() {
	}




}
