/*
 * PETALS: PETALS Services Platform
 * Copyright (C) 2005  EBM WebSourcing
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA.
 *
 * Initial developer(s): EBM WebSourcing
 * --------------------------------------------------------------------------
 * $Id: 
 * --------------------------------------------------------------------------  
 */

package org.objectweb.petals.admin.editparts.tree;

import java.beans.PropertyChangeEvent;

import org.objectweb.petals.admin.models.ComponentModel;
import org.objectweb.petals.admin.tools.ImageDatas;

/**
* @author Maxime Carpentier
 * Tree graphical representation of a component model
 *
 */
public class ComponentTreeEditPart extends MyTreeEditPart {

  /**
 * @see org.eclipse.gef.editparts.AbstractEditPart#refreshVisuals()
 */
protected void refreshVisuals() {
  	ComponentModel model = (ComponentModel) getModel();
    setWidgetImage(ImageDatas._component_small);
    setWidgetText(model.getName());

  }

  /**
 * @see java.beans.PropertyChangeListener#propertyChange(java.beans.PropertyChangeEvent)
 */
public void propertyChange(PropertyChangeEvent evt) {
    if (evt.getPropertyName().equals(ComponentModel.P_NAME))
      refreshVisuals();
  }
}