/*
 * PETALS: PETALS Services Platform
 * Copyright (C) 2005  EBM WebSourcing
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA.
 *
 * Initial developer(s): EBM WebSourcing
 * --------------------------------------------------------------------------
 * $Id: 
 * --------------------------------------------------------------------------  
 */

package org.objectweb.petals.admin.editparts.tree;

import java.beans.PropertyChangeEvent;
import java.util.List;

import org.objectweb.petals.admin.models.ServiceContainerDirectoryModel;
import org.objectweb.petals.admin.tools.ImageDatas;

/**
* @author Maxime Carpentier
 * Tree graphical representation root 
 *
 */
public class ServiceContainerDirectoryTreeEditPart extends MyTreeEditPart {
  
  /**
 * @see org.eclipse.gef.editparts.AbstractEditPart#getModelChildren()
 */
protected List getModelChildren() {
    return ((ServiceContainerDirectoryModel) getModel()).getChildren();
  }
  /**
 * @see org.eclipse.gef.editparts.AbstractEditPart#refreshVisuals()
 */
protected void refreshVisuals() {
    setWidgetImage(ImageDatas._scdm_small);

  }
  /**
 * @see java.beans.PropertyChangeListener#propertyChange(java.beans.PropertyChangeEvent)
 */
public void propertyChange(PropertyChangeEvent evt) {
    if(evt.getPropertyName().equals(ServiceContainerDirectoryModel.P_CHILDREN))
      refreshChildren();
  }
}