/*
 * PETALS: PETALS Services Platform
 * Copyright (C) 2005  EBM WebSourcing
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA.
 *
 * Initial developer(s): EBM WebSourcing
 * --------------------------------------------------------------------------
 * $Id: 
 * --------------------------------------------------------------------------  
 */

package org.objectweb.petals.admin.editpolicies;

import org.eclipse.draw2d.ScrollPane;
import org.eclipse.gef.editpolicies.SelectionEditPolicy;
import org.objectweb.petals.admin.editparts.ComponentsEditPart;
import org.objectweb.petals.admin.editparts.ServiceContainerEditPart;

/**
 * 
 * @author Maxime Carpentier
 *
 * Component and agent selection edit policy : made to update container's scrollpane when selecting an agent or a component via the treeview
 */
public class MySelectionEditPolicy extends SelectionEditPolicy {

	/**
	 * @see org.eclipse.gef.editpolicies.SelectionEditPolicy#hideSelection()
	 */
	protected void hideSelection() {

	}

	/**
	 * @see org.eclipse.gef.editpolicies.SelectionEditPolicy#showSelection()
	 * Updats the value of the scrollbar regarding the current selected component
	 */
	protected void showSelection() {
		ComponentsEditPart parent = (ComponentsEditPart) getHost().getParent();
		ScrollPane fig = (ScrollPane) parent.getFigure();
		fig.scrollVerticalTo(getHostFigure().getBounds().y - ((ServiceContainerEditPart) getHost().getParent().getParent()).getFigure().getBounds().y - 30 + fig.getVerticalScrollBar().getValue());

	}

  
}