/*
 * PETALS: PETALS Services Platform
 * Copyright (C) 2005  EBM WebSourcing
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA.
 *
 * Initial developer(s): EBM WebSourcing
 * --------------------------------------------------------------------------
 * $Id: 
 * --------------------------------------------------------------------------  
 */

package org.objectweb.petals.admin.models;

/**
* @author Maxime Carpentier
 * Abstract model for all connections. The source has to be a containerModel and the target the esbmodel
 *
 */
public abstract class AbstractConnectionModel {
	  private EsbModel target;
	  private ServiceContainerModel source;

	public void attachSource() {
	    if (!source.getModelSourceConnections().contains(this))
	      source.addSourceConnection(this);
	  }


	public void attachTarget() {
	    if (!target.getModelTargetConnections().contains(this))
	      target.addTargetConnection(this);
	  }

	  public void detachSource() {
	    source.removeSourceConnection(this);
	  }

	  public void detachTarget() {
	    target.removeTargetConnection(this);
	  }

	  public ServiceContainerModel getSource() {
	    return source;
	  }

	  public EsbModel getTarget() {
	    return target;
	  }

	  public void setSource(ServiceContainerModel model) {
	    source = model;
	  }

	  public void setTarget(EsbModel model) {
	    target = model;
	  }
	}
