/*
 * PETALS: PETALS Services Platform
 * Copyright (C) 2005  EBM WebSourcing
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA.
 *
 * Initial developer(s): EBM WebSourcing
 * --------------------------------------------------------------------------
 * $Id: 
 * --------------------------------------------------------------------------  
 */

package org.objectweb.petals.admin.models;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.ArrayList;
import java.util.List;

import javax.naming.InitialContext;

import org.objectweb.petals.admin.EsbEditor;


/**
* @author Maxime Carpentier
*/
public class ServiceContainerDirectoryModel extends AbstractModel implements PropertyChangeListener {

	public static final String P_CHILDREN = "_children";
	private InitialContext ic;
	private static final String CONTAINERS_REF = "containers";  
	public static final String ENDPOINTS_REF="endpoints";
	private List children = new ArrayList(); 
	private ContentsServiceContainerModel top,bottom;
	private EsbEditor esbeditor;

	public ServiceContainerDirectoryModel(EsbEditor esbeditor) {
		this.esbeditor = esbeditor;
	}
	public void setTop(ContentsServiceContainerModel top) {
		this.top = top;
	}
	public void setBottom(ContentsServiceContainerModel bottom) {
		this.bottom = bottom;
	}
	
	/**
	 * @param child
	 */
	public void addChild(Object child) {
		children.add(child);
		firePropertyChange(P_CHILDREN, null, null);
	}
	
	public void addContainer(Object child) {
		top.addChild(child);
	}
	
	
	/*public void getEndpoints(ContainerDescription cd) throws NamingException {
        String name = "" ;

        for(NamingEnumeration e = ic.listBindings(ENDPOINTS_REF);e.hasMore();)
        {
            Binding tmp = (Binding)e.next();
            name  = tmp.getName();
            if (name.equalsIgnoreCase(cd.toString())) { esbeditor.addEndpoint((Address)tmp.getObject(),cd); }
        }
	}*/
	/**
	 * @return The children
	 */
	public List getChildren() {
		return children;
	}
	
	/**
	 * @param child
	 */
	public void removeChild(Object child) {
		children.remove(child);
		firePropertyChange(P_CHILDREN, null, null);

	}

	/**
	 * @see java.beans.PropertyChangeListener#propertyChange(java.beans.PropertyChangeEvent)
	 * called when the structure of its child list has changed
	 */
	public void propertyChange(PropertyChangeEvent arg0) {
		if (arg0.getPropertyName().equals(ContentsServiceContainerModel.P_CHILDREN)) {
			ContentsServiceContainerModel mdl = ((ContentsServiceContainerModel) arg0.getOldValue());
			if (arg0.getNewValue() != null) { //newValue = child to remove
				removeChild(arg0.getNewValue());
			}
			else { 
				for (int i = 0; i < mdl.getChildren().size(); i++) {		
					if (getChildren().indexOf(mdl.getChildren().get(i)) < 0) {
						addChild(mdl.getChildren().get(i));
					}
				}
			}
		}
	}

}