/*
 * PETALS: PETALS Services Platform
 * Copyright (C) 2005  EBM WebSourcing
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA.
 *
 * Initial developer(s): EBM WebSourcing
 * --------------------------------------------------------------------------
 * $Id: 
 * --------------------------------------------------------------------------  
 */

package org.objectweb.petals.admin.models.commands;

import org.eclipse.gef.commands.Command;
import org.objectweb.petals.admin.editparts.ServiceContainerEditPart;
import org.objectweb.petals.admin.models.ContentsServiceContainerModel;
import org.objectweb.petals.admin.models.ServiceContainerModel;

/**
* @author Maxime Carpentier
*/
public class AddServiceContainerCommand extends Command {
	private ServiceContainerModel model,model_after;
	private ContentsServiceContainerModel contents;
	private ContentsServiceContainerModel oldContents;
	private int old_index;
	
	/**
	 * @param contents
	 * @param partChild
	 * @param after
	 * create a command to add a new service container to the model
	 */
	public AddServiceContainerCommand(Object contents,Object partChild,Object after) {
		model=((ServiceContainerModel) ((ServiceContainerEditPart) partChild).getModel());
		model_after=(after != null)?(ServiceContainerModel) after:null;
		this.contents=(ContentsServiceContainerModel) contents;
		this.oldContents = (ContentsServiceContainerModel) ((ServiceContainerEditPart) partChild).getParent().getModel();
		 old_index = oldContents.getChildren().indexOf(model);
	}
	/**
	 * @see org.eclipse.gef.commands.Command#execute()
	 */
	public void execute() {
		if (model_after != null) {
			oldContents.removeChild(model);
			contents.addChild(model,contents.getChildren().indexOf(model_after));
		}
		else {
			oldContents.removeChild(model);
			contents.addChild(model);
		}
	}

	/**
	 * @see org.eclipse.gef.commands.Command#undo()
	 */
	public void undo() {
		contents.removeChild(model);
		oldContents.addChild(model,old_index);
	}

}
