/*
 * PETALS: PETALS Services Platform
 * Copyright (C) 2005  EBM WebSourcing
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA.
 *
 * Initial developer(s): EBM WebSourcing
 * --------------------------------------------------------------------------
 * $Id: 
 * --------------------------------------------------------------------------  
 */

package org.objectweb.petals.admin.models.commands;


import org.eclipse.gef.commands.Command;
import org.objectweb.petals.admin.models.AgentModel;
import org.objectweb.petals.admin.models.TransportModel;


/**
 * @author Maxime Carpentier
 * this command creates a new agent to add to a Transport model
 */
public class CreateAgentCommand extends Command {
  private TransportModel transportModel;
  private AgentModel agentModel;
  
  /**
 * @see org.eclipse.gef.commands.Command#execute()
 */
public void execute() {
  	transportModel.addChild(agentModel);
  }

  /**
 * @param model
 */
public void setContentsModel(Object model) {
  	transportModel = (TransportModel) model;
  }

  /**
 * @param model
 */
public void setComponentModel(Object model) {
  	agentModel = (AgentModel) model;
  }

  /**
 * @see org.eclipse.gef.commands.Command#undo()
 */
public void undo() {
  	transportModel.removeChild(agentModel);
  }
}