/*
 * PETALS: PETALS Services Platform
 * Copyright (C) 2005  EBM WebSourcing
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA.
 *
 * Initial developer(s): EBM WebSourcing
 * --------------------------------------------------------------------------
 * $Id: 
 * --------------------------------------------------------------------------  
 */

package org.objectweb.petals.admin.models.commands;

import org.eclipse.gef.commands.Command;
import org.objectweb.petals.admin.models.ComponentModel;
import org.objectweb.petals.admin.models.ComponentsModel;


/**
 * @author Maxime Carpentier
 *	This class can move a component into a Components Model
 */
public class MoveComponentCommand extends Command {
	private ComponentModel model,model_after;
	private ComponentsModel contents;
	private int oldIndex;
	
	/**
	 * @param contents
	 * @param child
	 * @param after
	 */
	public MoveComponentCommand(Object contents,Object child,Object after) {
		model=(ComponentModel) child;
		model_after=(after != null)?(ComponentModel) after:null;
		this.contents=(ComponentsModel) contents;
		oldIndex = this.contents.getChildren().indexOf(model);
	}
	/**
	 * @see org.eclipse.gef.commands.Command#execute()
	 */
	public void execute() {
		if (model_after != null)
			contents.moveChild(contents.getChildren().indexOf(model_after),model);
		else
			contents.moveChild(contents.getChildren().size()-1,model);
	}

	/**
	 * @see org.eclipse.gef.commands.Command#undo()
	 */
	public void undo() {
		contents.moveChild(oldIndex,model);
	}
}
