/*
 * PETALS: PETALS Services Platform
 * Copyright (C) 2005  EBM WebSourcing
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA.
 *
 * Initial developer(s): EBM WebSourcing
 * --------------------------------------------------------------------------
 * $Id: 
 * --------------------------------------------------------------------------  
 */

package org.objectweb.petals.admin.states;

import java.util.HashMap;

import org.eclipse.swt.graphics.Image;
import org.objectweb.petals.admin.EsbEditor;
import org.objectweb.petals.admin.actions.EsbAction;


/**
 * @author Maxime Carpentier
 * A state provides an image and a list of associated actions for a component,an agent or a container
 */
public class State {
	private String name;
	private Image image;
	private HashMap actions = new HashMap();
	private EsbEditor editor;
	private String id;
	
	public String toString() {
		return name + " ( " + actions.values() +" )";
		
	}
	public State(String name,Image image,String id, EsbEditor editor) {
		this.name = name;
		this.image = image;
		this.editor = editor;
		this.id=id;
	}
	/**
	 * @return Returns the commands.
	 */
	public HashMap getActions() {
		return actions;
	}
	/**
	 * @param commands The commands to set.
	 */
	public void setActions(HashMap actions) {
		this.actions = actions;
	}
	/**
	 * @return Returns the image.
	 */
	public Image getImage() {
		return image;
	}
	/**
	 * @param image The image to set.
	 */
	public void setImage(Image image) {
		this.image = image;
	}
	/**
	 * @return Returns the name.
	 */
	public String getName() {
		return name;
	}
	/**
	 * @param name The name to set.
	 */
	public void setName(String name) {
		this.name = name;
	}
	
	public void addAction(EsbAction action) {
		actions.put(action.getId(),action);
		editor.addAction(action);
	}

	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
}
