/*
 * PETALS: PETALS Services Platform
 * Copyright (C) 2005  EBM WebSourcing
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA.
 *
 * Initial developer(s): EBM WebSourcing
 * --------------------------------------------------------------------------
 * $Id: 
 * --------------------------------------------------------------------------  
 */

package org.objectweb.petals.admin.tools;

import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.FlowLayout;
import org.eclipse.draw2d.ImageFigure;
import org.eclipse.draw2d.Label;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.Image;
import org.objectweb.petals.admin.states.State;


/**
 * @author Maxime Carpentier
 *	Custom graphical representation of a component
 */
public class ComponentFigure extends Figure {
	public final static int P_WIDTH = 62;
	public final static int P_HEIGHT = 58;
	private FixedSizeLabel label = new FixedSizeLabel(62);
	private State state;
	private ImageFigure imgfig;
	private FlowLayout fl ;
	
	public ComponentFigure(State state) {
	  	this.state= state;
	  	fl = new FlowLayout(false);
		fl.setMinorAlignment(FlowLayout.ALIGN_CENTER);
		fl.setMinorSpacing(0);
		this.setLayoutManager(fl);
		Image img = state.getImage();
		 imgfig = new ImageFigure();
		imgfig.setImage(img);
		this.setPreferredSize(P_WIDTH,P_HEIGHT);
		this.setSize(P_WIDTH,P_HEIGHT);

		this.add(imgfig);
		this.add(label);
	}

	public void setName(String name) {
		label.setText(label.getSubStringText(name));
		label.setFont(new Font(null,"MS Sans Serif",8,0));
		label.setToolTip(new Label(name));
	}
	
	public void setImg(Image arg) {
		imgfig.setImage(arg);
	}

}
