/*
 * PETALS: PETALS Services Platform
 * Copyright (C) 2005  EBM WebSourcing
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA.
 *
 * Initial developer(s): EBM WebSourcing
 * --------------------------------------------------------------------------
 * $Id: 
 * --------------------------------------------------------------------------  
 */

package org.objectweb.petals.admin.tools;

import org.eclipse.draw2d.FlowLayout;
import org.eclipse.draw2d.ImageFigure;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.Panel;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.ImageData;


/**
 * @author Maxime Carpentier
 * Custom Graphical representation of a container's title
 */
public class ComponentsTitleFigure extends Panel {
	private Label label = new Label();
	
	/**
	 * @param name
	 * @param width
	 * @param arg
	 *  build the figure
	 */
	public ComponentsTitleFigure(String name,int width) {
	  	FlowLayout fl = new FlowLayout(true);
		fl.setMinorAlignment(FlowLayout.ALIGN_CENTER);
		fl.setMinorSpacing(0);
		this.setLayoutManager(fl);
		
		Image left = ImageDatas._serviceContainerTitle_left;
		Image mid = ImageDatas._serviceContainerTitle_mid;
		Image right = ImageDatas._serviceContainerTitle_right;
		
		Image img= ImageDatas._serviceContainerTitle;

		ImageData temp = img.getImageData().scaledTo((width-left.getBounds().width-right.getBounds().width-mid.getBounds().width)/2,img.getBounds().height);
		ImageData temp2;
		if (width % 2  == 0) {
			 temp2 = img.getImageData().scaledTo((width-left.getBounds().width-right.getBounds().width-mid.getBounds().width)/2+1,img.getBounds().height);
		}
		else {
			temp2 = img.getImageData().scaledTo((width-left.getBounds().width-right.getBounds().width-mid.getBounds().width)/2 ,img.getBounds().height);
		}
		
		Image cont_left = new Image(null,temp);
		Image cont_right = new Image(null,temp2);
		
		ImageFigure img_mid = new ImageFigure();
		FlowLayout fl1 = new FlowLayout(false);
		fl1.setMajorAlignment(FlowLayout.ALIGN_CENTER);
		fl1.setMinorAlignment(FlowLayout.ALIGN_CENTER);
		fl1.setStretchMinorAxis(true);
		img_mid.setLayoutManager(fl1);
		
		img_mid.setImage(mid);
		img_mid.add(new Label("            "));
		img_mid.add(label);
		setName(name);
		
		ImageFigure img_left = new ImageFigure(left);
		ImageFigure img_right = new ImageFigure(right);
		ImageFigure img_cont_left = new ImageFigure(cont_left);
		ImageFigure img_cont_right = new ImageFigure(cont_right);

		
		this.add(img_left);
		this.add(img_cont_left);
		this.add(img_mid);
		this.add(img_cont_right);
		this.add(img_right);
		
		this.setPreferredSize(width,left.getBounds().height);

	}

	public void setName(String name) {
		label.setText(name);
		label.setFont(new Font(null,"MS Sans Serif",8,0));
		label.setToolTip(new Label(name));
	}


}
	
	 
