/*
 * PETALS: PETALS Services Platform
 * Copyright (C) 2005  EBM WebSourcing
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA.
 *
 * Initial developer(s): EBM WebSourcing
 * --------------------------------------------------------------------------
 * $Id: 
 * --------------------------------------------------------------------------  
 */

package org.objectweb.petals.admin.tools;

import java.awt.image.BufferedImage;

import org.eclipse.draw2d.FlowLayout;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.ImageFigure;
import org.eclipse.draw2d.Panel;
import org.eclipse.swt.graphics.Image;
import org.objectweb.petals.admin.editparts.ContentsServiceContainerEditPart;
import org.objectweb.petals.admin.models.ComponentsModel;



/**
 * @author Maxime Carpentier
 * Graphical representation of the Esb
 */
public class EsbFigure extends Panel {
	
	private BufferedImage awtImage;
    private int size;
    private Image pattern = ImageDatas._esb_pattern;
   	private ImageFigure img_pattern_left;
   	private ImageFigure img_pattern_right;
   	public static int _MIN_SIZE = 500;
   	
	  /**
	 * @param arg
	 * build the figure regarding the current number of containers
	 */
	public EsbFigure(int arg) {
	    FlowLayout layout = new FlowLayout(true);
	    layout.setMinorSpacing(0);
	    setLayoutManager(layout);
	    size = arg;
	    int total_width  = ((size * (ComponentsModel.CalculateInitialContainerSize().width + ImageDatas._container_left.getImageData().width)) + (ContentsServiceContainerEditPart._SPACING * (size-1)) - 20);
	    int width = total_width > _MIN_SIZE ? total_width : _MIN_SIZE;
	    
	    
	    Image mid = ImageDatas._esb_mid;
	    Image pattern = ImageDatas._esb_pattern;
	    Image left = ImageDatas._esb_left;
	    Image right = ImageDatas._esb_right;

	    width = (width - mid.getImageData().width - left.getImageData().width - right.getImageData().width) / 2;
	   	Image pattern_left = new Image(null,pattern.getImageData().scaledTo(width,pattern.getImageData().height));
	   	Image pattern_right = new Image(null,pattern.getImageData().scaledTo(width,pattern.getImageData().height));
	   	
	    ImageFigure img_left = new ImageFigure(left);
	     img_pattern_left = new ImageFigure(pattern_left);
	    ImageFigure img_mid = new ImageFigure(mid);
	     img_pattern_right = new ImageFigure(pattern_right);
	    ImageFigure img_right = new ImageFigure(right);
	    
	    this.add(img_left);
	    this.add(img_pattern_left);
	    this.add(img_mid);
	    this.add(img_pattern_right);
	    this.add(img_right);
	  }
	  
	  /**
	 * @param arg
	 * Updates the esb size regarding the actual number of containers
	 */
	public void rebuild(int arg) {
	  	size=arg;
	   	this.remove(img_pattern_left);
	   	this.remove(img_pattern_right);
	   	
		   	
	    int total_width  = ((size * (ComponentsModel.CalculateInitialContainerSize().width + ImageDatas._container_left.getImageData().width)) + (ContentsServiceContainerEditPart._SPACING * (size-1)) - 20);
	    int width = total_width > _MIN_SIZE ? total_width : _MIN_SIZE;
	    
	    
	    Image mid = ImageDatas._esb_mid;
	    Image pattern = ImageDatas._esb_pattern;
	    Image left = ImageDatas._esb_left;
	    Image right = ImageDatas._esb_right;

	    width = (width - mid.getImageData().width - left.getImageData().width - right.getImageData().width) / 2;
	   	Image pattern_left = new Image(null,pattern.getImageData().scaledTo(width,pattern.getImageData().height));
	   	Image pattern_right = new Image(null,pattern.getImageData().scaledTo(width,pattern.getImageData().height));
	   		   	
	   	img_pattern_left = new ImageFigure(pattern_left);
	   	img_pattern_right = new ImageFigure(pattern_right);

	   	this.add(img_pattern_left,1);
	   	this.add(img_pattern_right,3);
	  }
	  
		public void addChild(IFigure figure) {
			add(figure);
			this.repaint();
		}
		
}
	 
