/*
 * PETALS: PETALS Services Platform
 * Copyright (C) 2005  EBM WebSourcing
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA.
 *
 * Initial developer(s): EBM WebSourcing
 * --------------------------------------------------------------------------
 * $Id: ContainerDirectory.java,v 1.3 2005/07/22 10:24:27 alouis Exp $
 * --------------------------------------------------------------------------  
 */

package org.objectweb.petals.directory;

import javax.jbi.JBIException;

import org.objectweb.petals.component.SystemServiceLifeCycle;
import org.objectweb.petals.description.ContainerDescription;


/**
 * Provide the container referencing management in the directory.
 * @author Adrien LOUIS - EBM WebSourcing
 */
public interface ContainerDirectory extends SystemServiceLifeCycle{
    
    /**
     * register the container
     * @param cr
     * @throws JBIException directory accessing problem,  containerName is null or already exists
     */
    void registerContainer(ContainerDescription cr)
    throws JBIException;
    
    /**
     * unregister the container and its subcontext
     * @param cr
     * @throws JBIException directory accessing problem, containerName not found or is null
     */
    void unregisterContainer(ContainerDescription cr)
    throws JBIException;
    
    /**
     * find a <code>ContainerReference</code> by its name
     * @param containerName
     * @return
     * @throws  JBIException directory accessing problem, containerName is null
     */
    ContainerDescription findContainerByName(String containerName)
    throws JBIException;   
}