/*
 * PETALS: PETALS Services Platform
 * Copyright (C) 2005  EBM WebSourcing
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA.
 *
 * Initial developer(s): EBM WebSourcing
 * --------------------------------------------------------------------------
 * $Id: ActivityLauncher.java,v 1.2 2005/07/22 10:24:27 alouis Exp $
 * --------------------------------------------------------------------------  
 */

package org.objectweb.petals.management.activity;

import org.objectweb.petals.component.LifeCycleElement;




/**
 * Used to launch activities in separate threads.
 * Activities are :
 * - start an element,
 * - stop an element,
 * - shutdown an element,
 * - install an element,
 * - uninstall an element,
 * 
 * when <code>ActivityLauncher</code> thread start, it execute the
 * specified <code>Command</code> on the <code>LifeCycleElement</code>.
 * 
 * @author Adrien LOUIS - EBM WebSourcing
 */
public class ActivityLauncher extends Thread 
{
    
    protected LifeCycleElement element;
    protected Command command;
    
    public ActivityLauncher(LifeCycleElement element, Command command)
    {
        this.element = element;
        this.command = command;
    }
    
    public void run()
    {
        if(command != null)
        {
            command.execute(element);
        }
    }
    
}
