/*
 * PETALS: PETALS Services Platform
 * Copyright (C) 2005  EBM WebSourcing
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA.
 *
 * Initial developer(s): EBM WebSourcing
 * --------------------------------------------------------------------------
 * $Id: Command.java,v 1.2 2005/07/22 10:24:27 alouis Exp $
 * --------------------------------------------------------------------------  
 */

package org.objectweb.petals.management.activity;

import org.objectweb.petals.component.LifeCycleElement;

/**
 * Interface defining the command used to launch a lifecycle change
 * on a <code>LifeCycleElement</code>.
 * @author Adrien LOUIS - EBM WebSourcing
 */
public interface Command
{
    /**
     * Execute the command on the specified <code>LifeCycleElement</code>.
     * The command is a call to <code>LifeCycleElement</code> methods:
     * - startElement,
     * - stopElement,
     * - shutdownElement,
     * - installElement,
     * - uninstallElement
     * 
     * If <code>LifeCycleElement</code> is null, do nothing.
     */
    void execute(LifeCycleElement element);
}
