/*
 * PETALS: PETALS Services Platform
 * Copyright (C) 2005  EBM WebSourcing
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA.
 *
 * Initial developer(s): EBM WebSourcing
 * --------------------------------------------------------------------------
 * $Id: ESBLogger.java,v 1.2 2005/07/22 10:24:27 alouis Exp $
 * --------------------------------------------------------------------------  
 */

package org.objectweb.petals.util;


import java.io.IOException;
import java.net.URL;
import java.util.logging.LogManager;

/**
 * Various log methods used by the container.
 * @author Adrien LOUIS - EBM WebSourcing
 */
public class ESBLogger{
    
    protected static java.util.logging.Logger esbLogger;
    
    static
    {
        try 
        {
            URL url = ESBLogger.class.getResource("/logging.properties");
            
            LogManager.getLogManager().readConfiguration(url.openStream());
        } 
        catch (IOException e) 
        {
            e.printStackTrace();
        }
        esbLogger = java.util.logging.Logger.getLogger("org.objectweb.petals");
    }
    
    public static void logFinest(String method)
    {
        esbLogger.log(java.util.logging.Level.FINEST,method);
    }
    
    public static void logFine(String method)
    {
        esbLogger.log(java.util.logging.Level.FINE,method);
    }
    
    public static void logSevere(String msg, Throwable t)
    {
        esbLogger.log(java.util.logging.Level.SEVERE,msg,t);
    }
    
    public static void logInfo(String msg)
    {
        esbLogger.log(java.util.logging.Level.INFO,msg);
    }
    
    public static void logWarning(String msg)
    {
        esbLogger.log(java.util.logging.Level.WARNING,msg);
    }
    
    public static void logWarning(String msg, Throwable t)
    {
        esbLogger.log(java.util.logging.Level.WARNING,msg,t);
    }
    
    
    
    public static void logFinest(Object o ,String method)
    {
        esbLogger.logp(java.util.logging.Level.FINEST,clazz(o),method,method);
    }
    
    public static void logFine(Object o ,String method)
    {
        esbLogger.logp(java.util.logging.Level.FINE,clazz(o),method,method);
    }
    
    public static void logSevere(Object o ,String method, Throwable t)
    {
        esbLogger.logp(java.util.logging.Level.SEVERE,clazz(o),method,method,t);
    }
    
    public static void logInfo(Object o ,String method)
    {
        esbLogger.logp(java.util.logging.Level.INFO,clazz(o),method,method);
    }
    
    public static void logWarning(Object o ,String method)
    {
        esbLogger.logp(java.util.logging.Level.WARNING,clazz(o),method,method);
    }
    
    public static void logWarning(Object o ,String msg, Throwable t)
    {
        esbLogger.log(java.util.logging.Level.WARNING,classAndMethod(o,msg),t);
    }
    
    protected static String classAndMethod(Object o, String method)
    {
        return o.getClass().getName()+" "+method;
    }
    protected static String clazz(Object o)
    {
        return o.getClass().getName();
    }
}
