/*
 * PETALS: PETALS Services Platform
 * Copyright (C) 2005  EBM WebSourcing
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA.
 *
 * Initial developer(s): EBM WebSourcing
 * --------------------------------------------------------------------------
 * $Id: ContainerDescription.java,v 1.1 2005/07/22 10:24:27 alouis Exp $
 * --------------------------------------------------------------------------  
 */

package org.objectweb.petals.description;

import java.io.Serializable;


/**
 * @author Adrien LOUIS - EBM WebSourcing
 *
 */
public class ContainerDescription implements Serializable{

    private String host;
    
    private String name;
    
    private int adminPort;

    public ContainerDescription(String name, String host,int adminPort)
    {
        this.host = host;
        
        this.name = name;
        
        this.adminPort = adminPort;
    }
    
    public String getHost() {
        return host;
    }
      
    public String getName() {
        return name;
    }
    
    public int getAdminPort()
    {
        return adminPort;
    }
    public String toString()
    {
        return "ServiceContainerReference@["+host+":"+adminPort+"]"+name;
    }
    
    public boolean equals(Object o)
    {
    	if (o != null && o instanceof ContainerDescription)
    	{
    		ContainerDescription cd = (ContainerDescription) o;
    		
    		boolean hostOk=false;
    		if (cd.getHost() != null){
    			hostOk= cd.getHost().equals(getHost()); 
    		}
    		else{
    			hostOk = (getHost() == null);
			}
    		
    		boolean nameOk=false;
    		if (cd.getName() != null) {
    			nameOk = cd.getName().equals(getName()); 
    		}
    		else{
    			nameOk = (getName() == null);
			}
    		
    		boolean portOk=(cd.getAdminPort() == getAdminPort()); 
    		
    		return (hostOk && nameOk && portOk);
    	}
   		return false;
    }
    
}
