#!/bin/sh

# Verify if JAVA_HOME is well defined
if [ ! -r "$JAVA_HOME"/bin/java ]; then
  echo "The JAVA_HOME environment variable is not defined correctly"
  echo "This environment variable is needed to run this program"
  exit 1
fi

# Verify if PETALS_HOME is well defined
if [ ! -r "$PETALS_HOME"/bin/startup1.sh ]; then
  echo "The PETALS_HOME environment variable is not defined correctly"
  echo "This environment variable is needed to run this program"
  exit 1
fi

export CLASSPATH=$PETALS_HOME/conf/container1

export CLASSPATH=$CLASSPATH:$PETALS_HOME/lib/jbi.jar

export CLASSPATH=$CLASSPATH:$PETALS_HOME/lib/petals-commons.jar
export CLASSPATH=$CLASSPATH:$PETALS_HOME/lib/petals-core.jar
export CLASSPATH=$CLASSPATH:$PETALS_HOME/lib/petals-ebmSystemServicesImpl.jar
export CLASSPATH=$CLASSPATH:$PETALS_HOME/lib/serviceSamples.jar

export CLASSPATH=$CLASSPATH:$PETALS_HOME/lib/activation.jar
export CLASSPATH=$CLASSPATH:$PETALS_HOME/lib/jms.jar

export CLASSPATH=$CLASSPATH:$PETALS_HOME/lib/joram-client.jar
export CLASSPATH=$CLASSPATH:$PETALS_HOME/lib/jakarta-regexp-1.2.jar
export CLASSPATH=$CLASSPATH:$PETALS_HOME/lib/JCup.jar
export CLASSPATH=$CLASSPATH:$PETALS_HOME/lib/joram-mom.jar
export CLASSPATH=$CLASSPATH:$PETALS_HOME/lib/joram-shared.jar
export CLASSPATH=$CLASSPATH:$PETALS_HOME/lib/ow_monolog.jar

export CLASSPATH=$CLASSPATH:$PETALS_HOME/lib/jax-1_1-fr-qname-class.jar

export CLASSPATH=$CLASSPATH:$PETALS_HOME/lib/jmxri.jar
export CLASSPATH=$CLASSPATH:$PETALS_HOME/lib/jmxremote.jar

$JAVA_HOME/bin/java org.objectweb.petals.Main 
